from graphics_and_games_klassen import Turtle

class Kurve:
    """
    Zeichnet die Levy-C-Kurve
    """
    def __init__(self):
        """
        Legt die Turtle an
        """
        self.t = Turtle()
        self.t.StiftHeben()
        self.t.PositionSetzen(350, 250)
        self.t.StiftSenken()

    def KurveZeichnen(self, tiefe, farbe):
        """
        Zeichnet die Levy-C-Kurve mit der gegebenen Tiefe in der angegebenen Farbe.
        :param tiefe: Rekursionstiefe
        :param farbe: die Linienfarbe
        """
        self.t.Loeschen()
        self.t.FarbeSetzen(farbe)
        self.t.PositionSetzen(350, 250)
        self.SchrittAusführen(150, tiefe)
        

    def KurveZeichnen0bis3(self):
        """
        Zeichnet die Levy-C-Kurve mit den Tiefen 0 bis 3
        """
        self.t.Löschen()
        self.t.FarbeSetzen('schwarz')
        self.t.PositionSetzen(350, 250)
        self.SchrittAusführen(150, 0)
        self.t.FarbeSetzen('rot')
        self.t.PositionSetzen(350, 250)
        self.SchrittAusführen(150, 1)
        self.t.FarbeSetzen('gruen')
        self.t.PositionSetzen(350, 250)
        self.SchrittAusführen(150, 2)
        self.t.FarbeSetzen('blau')
        self.t.PositionSetzen(350, 250)
        self.SchrittAusführen(150, 3)

    def SchrittAusführen(self, länge, tiefe):
        """
        Zeichnet ein Element der Kurve durch Ausführen des nächsten Rekursionsschrittes
        :param länge: die Linienlänge
        :param tiefe: die (restliche) Rekursionstiefe
        """
        if tiefe > 0:
            self.t.Drehen(45)
            self.SchrittAusführen(länge * 0.7071, tiefe - 1)
            self.t.Drehen(-90)
            self.SchrittAusführen(länge * 0.7071, tiefe - 1)
            self.t.Drehen(45)
        else:
            self.t.Gehen(länge)
            
            
k=Kurve()
k.KurveZeichnen(10,'schwarz')