import time
from graphics_and_games_klassen import Ereignisbehandlung, Rechteck, Kreis
class ScheibenSymbol:
    """
    Stellt eine Scheibe auf dem Bildschirm dar
    """

    def __init__(self, nummer):
        """
        Legt die beiden Rechtecke an und positioniert Sie auf  1
        :param nummer die Scheibennummer
        """
        self.basis = 20
        self.x = 0
        self.y = 0
        self.breite = self.basis * nummer
        self.außen = Rechteck()
        self.außen.FarbeSetzen("schwarz")
        self.außen.GroesseSetzen(self.basis * nummer, self.basis)
        self.innen = Rechteck()
        self.innen.FarbeSetzen("rot")
        self.innen.GroesseSetzen(self.basis * nummer - 2, self.basis - 2)
        self.PositionSetzen(1, 1)
    
    
    def PositionSetzen (self, turmNummer, scheibenNummer):
        """
        Setzt die Position bei der Lage in einem Turm.
        :param turmNummer: Nummer des Turms
        :param scheibenNummer: Nummer der Scheibe von unten her ab 1
        """
        self.abstand = 250
        self.x = self.abstand / 2 + self.abstand * turmNummer - self.außen.breite / 2
        self.y = 400 - self.basis * (scheibenNummer + 1)
        self.außen.PositionSetzen(self.x, self.y)
        self.innen.PositionSetzen(self.x + 1, self.y + 1)
    

    def Anheben (self):
        """
        Bewegt die Scheibe um zwei Punkte nach oben.
        """
        self.y -= 2
        self.außen.PositionSetzen(self.x, self.y)
        self.innen.PositionSetzen(self.x + 1, self.y + 1)
    

    def Absenken (self):
        """
        Bewegt die Scheibe um zwei Punkte nach unten.
        """
        self.y += 2
        self.außen.PositionSetzen(self.x, self.y)
        self.innen.PositionSetzen(self.x + 1, self.y + 1)
    

    def LinksFahren (self):
        """
        Bewegt die Scheibe um zwei Punkte nach links.
        """
        self.x -= 2
        self.außen.PositionSetzen(self.x, self.y)
        self.innen.PositionSetzen(self.x + 1, self.y + 1)
    
    
    def RechtsFahren (self):
        """
        Bewegt die Scheibe um zwei Punkte nach rechts.
        """
        self.x += 2
        self.außen.PositionSetzen(self.x, self.y)
        self.innen.PositionSetzen(self.x + 1, self.y + 1)
    


class Kran:
    """
    Der Kran
    """
    def __init__(self):
        """
        Legt die Figuren an und positioniert den Kran
        """
        self.x = 250 / 2 - 15
        self.y = 100
        self.träger = Rechteck()
        self.träger.FarbeSetzen("blau")
        self.träger.GroesseSetzen(30, 6)
        self.seil = Rechteck()
        self.seil.FarbeSetzen("blau")
        self.seil.GroesseSetzen(2, self.y - 60)
        self.haken = Rechteck()
        self.haken.FarbeSetzen("blau")
        self.haken.GroesseSetzen(10, 2)
        self.rad1 = Kreis()
        self.rad1.FarbeSetzen("blau")
        self.rad1.RadiusSetzen(5)
        self.rad2 = Kreis()
        self.rad2.FarbeSetzen("blau")
        self.rad2.RadiusSetzen(5)
        self.PositionSetzen(0)
    
    def PositionSetzen (self, turmNummer):
        """
        Setzt die Position bei einem Turm
        :param turmNummer: Nummer des s
        """
        self.x = 250 / 2  + turmNummer * 250 - 15
        self.träger.PositionSetzen(self.x, 57)
        self.seil.PositionSetzen(self.x + 14, 60)
        self.seil.GroesseSetzen(2, self.y - 60)
        self.haken.PositionSetzen(self.x + 10, self.y - 2)
        self.rad1.PositionSetzen(self.x, 60)
        self.rad2.PositionSetzen(self.x + 30, 60)
    
    
    def Anheben (self):
        """
        Bewegt die Scheibe um zwei Punkte nach oben.
        """
        self.y -= 2
        self.träger.PositionSetzen(self.x, 57)
        self.seil.PositionSetzen(self.x + 14, 60)
        self.seil.GroesseSetzen(2, self.y - 60)
        self.haken.PositionSetzen(self.x + 10, self.y - 2)
        self.rad1.PositionSetzen(self.x, 60)
        self.rad2.PositionSetzen(self.x + 30, 60)
    
    def Absenken (self):
        """
        Bewegt die Scheibe um zwei Punkte nach unten.
        """
        self.y += 2
        self.träger.PositionSetzen(self.x, 57)
        self.seil.PositionSetzen(self.x + 14, 60)
        self.seil.GroesseSetzen(2, self.y - 60)
        self.haken.PositionSetzen(self.x + 10, self.y - 2)
        self.rad1.PositionSetzen(self.x, 60)
        self.rad2.PositionSetzen(self.x + 30, 60)

    def LinksFahren (self):
        """
        Bewegt die Scheibe um zwei Punkte nach links.
        """
        self.x -= 2
        self.träger.PositionSetzen(self.x, 57)
        self.seil.PositionSetzen(self.x + 14, 60)
        self.haken.PositionSetzen(self.x + 10, self.y - 2)
        self.rad1.PositionSetzen(self.x, 60)
        self.rad2.PositionSetzen(self.x + 30, 60)
    
    def RechtsFahren (self):
        """
        Bewegt die Scheibe um zwei Punkte nach rechts.
        """
        self.x += 2
        self.träger.PositionSetzen(self.x, 57)
        self.seil.PositionSetzen(self.x + 14, 60)
        self.haken.PositionSetzen(self.x + 10, self.y - 2)
        self.rad1.PositionSetzen(self.x, 60)
        self.rad2.PositionSetzen(self.x + 30, 60)
    
    def KranpositionGeben(self):
        """
        Gibt die x-Position des Krans bezogen auf die Seilmitte
        :return kranposition: Position des Krans
        """
        return self.x + 15
    
    def KranhöheGeben(self):
        """
        Gibt die y-Position der Unterkante des self.kranhakens
        :return y: Kranhöhe
        """
        return self.y
    

class Darstellung(Ereignisbehandlung):
    """
    Verwaltung der Visualisierung
    """
    
    def __init__(self, scheibenAnzahl):
        """
        Baut die Darstellung auf und verwaltet die Türme und den Kran
        :param scheibenAnzahl: die Anzahl der Scheiben, die zu Beginn auf dem ersten Tur, liegt
        """
        super().__init__()
        self.bodenPosition = 400
        self.turmAbstand = 250
        self.TaktdauerSetzen(100)
        self.wartezeitZähler = 0
        self.boden = Rechteck()
        self.boden.FarbeSetzen("schwarz")
        self.boden.PositionSetzen(0, self.bodenPosition)
        self.boden.GroesseSetzen(self.turmAbstand * 3, 5)
        self.schiene = Rechteck()
        self.schiene.FarbeSetzen("schwarz")
        self.schiene.PositionSetzen(0, 50)
        self.schiene.GroesseSetzen(self.turmAbstand * 3, 5)
        self.turm1 = Rechteck()
        self.turm1.FarbeSetzen("schwarz")
        self.turm1.PositionSetzen(self.turmAbstand / 2 - 3, self.bodenPosition - 200)
        self.turm1.GroesseSetzen(6, 200)
        self.turm2 = Rechteck()
        self.turm2.FarbeSetzen("schwarz")
        self.turm2.PositionSetzen(self.turmAbstand * 3 / 2 - 3, self.bodenPosition - 200)
        self.turm2.GroesseSetzen(6, 200)
        self.turm3 = Rechteck()
        self.turm3.FarbeSetzen("schwarz")
        self.turm3.PositionSetzen(self.turmAbstand * 5 / 2 - 3, self.bodenPosition - 200)
        self.turm3.GroesseSetzen(6, 200)
        self.kran = Kran()
        self.turmAbstand = 250
        self.basis = 20
        self.türme = []
        self.türme.append([])
        self.türme.append([])
        self.türme.append([])
        for i in range (0, scheibenAnzahl):
            neu = ScheibenSymbol(scheibenAnzahl - i)
            neu.PositionSetzen(0, i)
            self.türme[0].append(neu)
            
    def AktionAusfuehren (self):
        """
        Die eigentliche Aktionsmethode des Zeitgebers.
        Erniedrigt den Zähler für die Wartezeit: 
        """
        self.wartezeitZähler -= 1
    
    def Warten (self, ticks):
        """
        Bremst den Ablauf, um eine beobachtbare Bewegung zu erhalten.
        :param ticks: die Anzahl der abzuwartenden Ticks der Ereignisbehandlung
        """
        self.wartezeitZähler = ticks
        while self.wartezeitZähler > 0:
            time.sleep(0.01)

    def Absenken (self, zielHöhe, scheibe):
        """
        Senkt den Kran, gegebenenfalls mit Scheibe, auf die gewünschte Höhe ab.
        :param zielHöhe: die gewünschte Höhe
        :param scheibe: Referenz der bewegten Scheibe.
        """
        while zielHöhe > self.kran.KranhöheGeben():
            self.kran.Absenken ()
            if not scheibe is None:
                scheibe.Absenken()
                self.Warten (3)
            else:
                self.Warten (1)
            

    def Anheben (self, scheibe):
        """
        Hebt den Kran, gegebenenfalls mit Scheibe, auf die Fahrhöhe an.
        :param scheibe: Referenz der bewegten Scheibe.
        """
        while 100 < self.kran.KranhöheGeben():
            self.kran.Anheben()
            if not scheibe is None:
                scheibe.Anheben()
                self.Warten (3)
            else:  
                self.Warten (1)
            
        
    def LinksFahren (self, zielPosition, scheibe):
        """
        Fährt den Kran, gegebenenfalls mit Scheibe, auf die gewünschte Position nach links.
        :param zielPosition: die gewünschte Position
        :param scheibe: Referenz der bewegten Scheibe.
        """
        while zielPosition < self.kran.KranpositionGeben():
        
            self.kran.LinksFahren ()
            if scheibe != None:
                scheibe.LinksFahren()
                self.Warten (3)
            else:
                self.Warten (1)
        

    def RechtsFahren (self, zielPosition, scheibe):
        """
        Fährt den Kran, gegebenenfalls mit Scheibe, auf die gewünschte Position nach rechts.
        :param zielPosition: die gewünschte Position
        :param scheibe: Referenz der bewegten Scheibe.
        """
        while zielPosition > self.kran.KranpositionGeben():
            self.kran.RechtsFahren ()
            if scheibe != None:
                scheibe.RechtsFahren()
                self.Warten (3)
            else:
                self.Warten (1)
            

    def Bewegen (self, start, ziel):
        """
        Bewegt die oberste Scheibe vom Startturm zum Zielturm.
        param start Nummer des Startturms
        param ziel Nummer des Zielturms
        """

        scheibenanzahl = len(self.türme[start])
        scheibe = self.türme[start].pop(scheibenanzahl - 1)
        position = self.turmAbstand / 2 + self.turmAbstand * start
        if position < self.kran.KranpositionGeben():
            self.LinksFahren (position, None)    
        elif position > self.kran.KranpositionGeben():
            self.RechtsFahren (position, None)
        self.Absenken (self.bodenPosition - self.basis * scheibenanzahl, None)
        self.Anheben (scheibe)
        position = self.turmAbstand / 2 + self.turmAbstand * ziel
        if position < self.kran.KranpositionGeben():
            self.LinksFahren(position, scheibe)
        elif position > self.kran.KranpositionGeben():
            self.RechtsFahren(position, scheibe)
        scheibenanzahl = len(self.türme[ziel]) + 1
        self.Absenken (self.bodenPosition - self.basis * scheibenanzahl, scheibe)
        self.türme[ziel].append(scheibe)
        self.Anheben(None)
    
    
class Hanoi:
    """
    Steuerklasse
    """

    def __init__(self, anzahl):
        """
        Legt die Darstellung an und startet den Ablauf
        :param anzahl: Anzahl der Scheiben auf dem Ausgangsturm
        """
        self.darstellung = Darstellung(anzahl)
        self.darstellung.Starten()
        self.Bewegen(anzahl, 0, 2)
    

    def TurmVerschieben(self, anzahlScheiben, von, nach):
        """
        Rekursive Steuermethode zur Bewegung des zu bewegenden (Teil-)Turms.
        :param anzahlScheiben: Anzahl der Scheiben des Turms
        :param von: Nummer des Ausgangsturms
        :param nach: Nummer des Zielturms
        """
        pass
        

    def BewegenScheibe(self, von, nach):
        """
        Bewegt die oberste Platte des Turms mit der Nummer von auf den Turm mit der Nummer nach
        :param von Nummer des Ausgangsturms
        :param nach Nummer des Zielturms        
        """
        self.darstellung.Bewegen(von, nach)
        
    

h=Hanoi(3)
h.TurmVerschieben(3,0,2)
