from graphics_and_games_klassen import Turtle

class SierpinskiKurve:
    """
    Zeichnet die Sierpinski-Kurve
    """
    def __init__(self, tiefe):
        """
        Konstruktor
        : param tiefe: Tiefe der Rekursion
        """
        self.t = Turtle()
        self.laenge = 125
        x0 = 400
        y0 = 250 - self.laenge
        for i in range(1, tiefe + 1):
            x0 -= self.laenge
            self.laenge /= 2.0
            y0 -= self.laenge
        self.laenge2 = self.laenge * 1.414213562373095  # sqrt(2)
        self.laenge *= 2.0
        self.t.StiftHeben()
        self.t.PositionSetzen(int(x0), int(y0))
        self.t.StiftSenken()
        self.ElementAZeichnen(tiefe)
        self.t.WinkelSetzen(315)
        self.t.Gehen(self.laenge2)
        self.ElementBZeichnen(tiefe)
        self.t.WinkelSetzen(225)
        self.t.Gehen(self.laenge2)
        self.ElementCZeichnen(tiefe)
        self.t.WinkelSetzen(135)
        self.t.Gehen(self.laenge2)
        self.ElementDZeichnen(tiefe)
        self.t.WinkelSetzen(45)
        self.t.Gehen(self.laenge2)

    def ElementAZeichnen(self, tiefe):
        """
        Zeichne Element A der Sierpinski-Kurve
        : param tiefe: Tiefe der Rekursion
        """
        if tiefe > 0:
            self.ElementAZeichnen(tiefe - 1)
            self.t.WinkelSetzen(315)
            self.t.Gehen(self.laenge2)
            self.ElementBZeichnen(tiefe - 1)
            self.t.WinkelSetzen(0)
            self.t.Gehen(self.laenge)
            self.ElementDZeichnen(tiefe - 1)
            self.t.WinkelSetzen(45)
            self.t.Gehen(self.laenge2)
            self.ElementAZeichnen(tiefe - 1)

    def ElementBZeichnen(self, tiefe):
        """
        Zeichne Element B der Sierpinski-Kurve
        : param tiefe: Tiefe der Rekursion
        """
        if tiefe > 0:
            self.ElementBZeichnen(tiefe - 1)
            self.t.WinkelSetzen(225)
            self.t.Gehen(self.laenge2)
            self.ElementCZeichnen(tiefe - 1)
            self.t.WinkelSetzen(270)
            self.t.Gehen(self.laenge)

    def ElementCZeichnen(self, tiefe):
        """
        Zeichne Element C der Sierpinski-Kurve
        : param tiefe: Tiefe der Rekursion
        """
        if tiefe > 0:
            self.ElementCZeichnen(tiefe - 1)
            self.t.WinkelSetzen(135)
            self.t.Gehen(self.laenge2)

    def ElementDZeichnen(self, tiefe):
        """
        Zeichne Element D der Sierpinski-Kurve
        : param tiefe: Tiefe der Rekursion
        """
        if tiefe > 0:
            self.ElementDZeichnen(tiefe - 1)